﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SWConfigDataClientLib;
using SWConfigDataClientLib.Proxies.Admin;
using SWConfigDataClientLib.WSUserPhoneBook;
using IpPbx.Samples.Shared;

namespace IpPbx.UserView
{
    public partial class frmMain : Form
    {
        private CDSLib cdsLib;

        //------------------------------------------------------------------------------------

        public frmMain()
        {
            InitializeComponent();            
        }
                
        //------------------------------------------------------------------------------------

        private void cmdLogin_Click(object sender, EventArgs e)
        {
            this.cdsLib = new CDSLib(txtName.Text,
                                     txtPassword.Text,
                                     txtServer.Text);

            if (this.cdsLib.TestConnection())
            {
                txtName.Enabled = false;
                txtPassword.Enabled = false;
                txtServer.Enabled = false;
                cmdLogin.Enabled = false;
                cmdUpdate.Enabled = false;
                cmdLoad.Enabled = true;
            }
            else
            {
                MessageBox.Show("Connection failed", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }           
        }

        //------------------------------------------------------------------------------------

        private void LoadView()
        {
            int i_RowId = 0;

            try
            {
                dgvPhonebook.Rows.Clear();

                UserAdminView1EntrySortableCollection userView = cdsLib.GetUserView(false);

                tslCounter.Text = "Results: " + userView.Count.ToString();

                foreach (UserAdminView1Entry entry in userView)
                {
                    i_RowId = dgvPhonebook.Rows.Add();
                    dgvPhonebook.Rows[i_RowId].Cells[0].Value = entry.UserID;
                    dgvPhonebook.Rows[i_RowId].Cells[1].Value = entry.Name;
                    dgvPhonebook.Rows[i_RowId].Cells[2].Value = entry.Comment;
                    dgvPhonebook.Rows[i_RowId].Cells[3].Value = entry.EMailAddr;
                    dgvPhonebook.Rows[i_RowId].Cells[4].Value = entry.Locked;
                    dgvPhonebook.Rows[i_RowId].Cells[5].Value = entry.LoginTimeLocal;
                }

                cmdLoad.Enabled = false;
                cmdUpdate.Enabled = true;
                userView = null;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Exception", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        //------------------------------------------------------------------------------------

        private void cmdLoad_Click(object sender, EventArgs e)
        {
            LoadView();
        }
        
        //------------------------------------------------------------------------------------

        private void cmdUpdate_Click(object sender, EventArgs e)
        {
            LoadView();
        }

        //------------------------------------------------------------------------------------

    }
}
