﻿using System;
using System.Windows.Forms;
using SWConfigDataClientLib;
using SWConfigDataClientLib.Proxies.Admin;
using SWConfigDataClientLib.Proxies.PhoneClient;
using SWConfigDataSharedLib.Exceptions;
using IpPbx.Samples.Shared;

namespace IpPbx.ViewActiveCalls
{
    public partial class frmMain : Form
    {
        private CDSLib cdsLib;
        
        //------------------------------------------------------------------------------------

        public frmMain()
        {
            InitializeComponent();
        }

        //------------------------------------------------------------------------------------

        private void cmdLogin_Click(object sender, EventArgs e)
        {
            this.cdsLib = new CDSLib(txtName.Text,
                                     txtPassword.Text,
                                     txtServer.Text);

            if (this.cdsLib.TestConnection())
            {
                txtName.Enabled = false;
                txtPassword.Enabled = false;
                txtServer.Enabled = false;
                cmdLogin.Enabled = false;
                cmdLoad.Enabled = true;
            }
            else
            {
                MessageBox.Show("Connection failed", "Error",
                    MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        //------------------------------------------------------------------------------------

        private void cmdLoad_Click(object sender, EventArgs e)
        {
            int i_RowId = 0;
            
            try
            {
                dgvPhonebook.Rows.Clear();

                ActiveCallEntrySortableCollection activeCalls = this.cdsLib.GetActiveCalls();

                tslCounter.Text = "Active Calls: " + activeCalls.Count.ToString();
                
                foreach (ActiveCallEntry callEntry in activeCalls)
                {
                    i_RowId = dgvPhonebook.Rows.Add();
                    dgvPhonebook.Rows[i_RowId].Cells[0].Value = callEntry.CallID.ToString();
                    dgvPhonebook.Rows[i_RowId].Cells[1].Value = callEntry.CallStatus.ToString();
                    dgvPhonebook.Rows[i_RowId].Cells[2].Value = callEntry.Start.ToString();
                    dgvPhonebook.Rows[i_RowId].Cells[3].Value = callEntry.Duration.ToString();
                    dgvPhonebook.Rows[i_RowId].Cells[4].Value = callEntry.CalledName;
                    dgvPhonebook.Rows[i_RowId].Cells[5].Value = callEntry.CalledNumber;
                    dgvPhonebook.Rows[i_RowId].Cells[6].Value = callEntry.DestinationDeviceName;
                    dgvPhonebook.Rows[i_RowId].Cells[7].Value = callEntry.DestinationName;
                    dgvPhonebook.Rows[i_RowId].Cells[8].Value = callEntry.DestinationNumber;
                    dgvPhonebook.Rows[i_RowId].Cells[9].Value = callEntry.OriginationDeviceName;
                    dgvPhonebook.Rows[i_RowId].Cells[10].Value = callEntry.OriginationName;
                    dgvPhonebook.Rows[i_RowId].Cells[11].Value = callEntry.OriginationNumber;
                    dgvPhonebook.Rows[i_RowId].Cells[12].Value = callEntry.ProjectNumber;
                    dgvPhonebook.Rows[i_RowId].Cells[13].Value = callEntry.Charges;
                }
                
                activeCalls = null;

                cmdLoad.Text = "Update";
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Exception", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
     
        //------------------------------------------------------------------------------------
    }
}
