﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using IpPbx.WebApplication.Models;
using IpPbx.Samples.Shared;
using SWConfigDataClientLib.Proxies.UserPhoneBook;
using SWConfigDataSharedLib.Tracing;

namespace IpPbx.WebApplication.Controllers
{
    public class IpPbxController : Controller
    {
        #region Tracing

        // Init user defined trace module named "CDSlib"
        // See Web.config for trace module configuration
        private static STraceInfo classTrace = new STraceInfo(new System.Diagnostics.TraceSwitch(
                                                              "IpPbxCt", "IpPbxCt", "2"),
                                                              typeof(IpPbxController));

        #endregion

        #region Methods

        public ActionResult Phonebook()
        {
            classTrace.TraceVerbose("Phonebook", "()");

            if ((bool)Session["IsAuthenticated"] != true)
            {
                return View("Error");
            }

            LogOnModel model = (LogOnModel)Session["LoginData"];

            CDSLib cdsLib = new CDSLib(model.UserName, model.Password, model.ServerAddress);
            var phonebookData = cdsLib.GetPbxPhonebook();

            return View(phonebookData);
        }

        public static string GetUserStateString(int stateId)
        {
            switch(stateId)
            {
                case 0:
                    return "Logged Off";

                case 1:
                    return "Available";

                case 2:
                    return "Speaking";

                case 3:
                    return "No state available";

                case 4:
                    return "Away";

                case 5:
                    return "Do not disturb";

            }

            return "Invalid state";
        }

        #endregion
    }
}
